--- uln-yum-mirror.orig	2014-01-21 23:26:26.000000000 +0100
+++ uln-yum-mirror	2014-02-18 12:41:20.172595280 +0100
@@ -142,17 +142,37 @@
 
   echo "## BEGIN PROCESSING $LABEL ##"
   # convert the channel label into a path suitable for our yum conventions
-  DIR=`echo $LABEL | sed -e 's/x86_64/x86-64/g' \
-        -e 's/oracle_addons/oracle-addons/g' -e 's/UEK_/UEK-/g' \
-        -e 's/Dtrace_/Dtrace-/g' -e 's/gdm_/gdm-/g' | \
-        sed 's/_u\([0-9][0-9]*\)_/_\1_/' | awk -F _ '{if($1!="exadata") \
-        {printf("%s/", toupper($1))} else {printf("%s/", $1)};count=1;\
-        while (++count<NF){if(count==NF-1) {print $(count+1)"/"$(count)} \
-        else{printf("%s/", $(count))}}}' | sed -e 's/x86-64/x86_64/g' \
-        -e 's/oracle-addons/oracle_addons/g' -e 's/UEK-/UEK\//g' \
-        -e 's/Dtrace-/Dtrace/g' -e 's/gdm-/gdm_/g'`
 
   # determine the correct yum repository directory
+  ARCHS="i386 x86_64 ia64"
+  MAIN_KEEP="exadata"
+  REP_KEEP="oracle_addons Dtrace_ gdm_"
+  # Find arch and remove it from label
+  for i in $ARCHS; do
+    if [[ $LABEL =~ ${i} ]]; then
+      REP_ARCH=${i}
+      LABEL_NOARCH=${LABEL/${i}_/}
+    fi  
+  done
+  echo "arch: $REP_ARCH ; label: $LABEL_NOARCH"
+  REP_MAIN=${LABEL_NOARCH%%_*}
+  # Make uppercase if not present in MAIN_KEEP
+  if ! { for i in $MAIN_KEEP; do [[ $REP_MAIN = "${i}" ]] && break; done }; then
+    REP_MAIN=${REP_MAIN^^}
+  fi
+  # Get the remainder of the label without the main name
+  REP_REMAIN=${LABEL_NOARCH#*_}
+  # Escape sublabels containing _ with - to prevent substitution
+  for l in $REP_KEEP; do
+    REP_REMAIN=${REP_REMAIN/${l}/${l/_/-}}
+  done
+  REP_REMAIN=${REP_REMAIN//_/\/}
+  # Unescape sublabels
+  for l in $REP_KEEP; do
+    REP_REMAIN=${REP_REMAIN/${l/_/-}/${l}}
+  done
+  DIR=$REP_MAIN/$REP_REMAIN/$REP_ARCH
+
   # set REP_DIR for further use in the repo file creation
   REP_DIR=$REP_UNK/$DIR
   echo $LABEL | grep '^exadata*_' >/dev/null 2>&1 && \
